;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Dissolve
;
; PRINT USR DISS;[CODE CHR "X"]
;
;================================
@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackA=0C02			;Move results to A
@DFile=400C			;Display File
@LastK=4025			;Key press value
@Seed=4032			;Random Number Seed
@Buff1=403C			;Fill value and Keypress flag

@Dissolve
	RST 20
	LD A,75			;Test for N/L
	INC A
	CP (HL)
	LD A,00			;Default Fill CHR
	JR Z NoPars		;Jump if no value specified
	CALL Class6		;Evaluate [Speed] expression
	RST 20 			;Get next character
	CALL Class6		;Evaluate [CODE "Chr X"] expression
	CALL StackA		;Move results to A, A=Fill chr
@NoPars
	LD (Buff1),A		;Store fill value
	JR Count		;"CALL Count"
@Outer
	PUSH DE			;PUSH counter
@Inner
	JR RNDNum		;"CALL RNDNum", range 0 to 792
@PrintFill
	LD E,(IY+60) 		;Get Fill chr
	LD HL,(DFile)		;Get a random DFile addr
	ADD HL,BC 		;Add random number to DFile
	LD A,75			;Test for N/L
	INC A
	CP (HL)
	JR Z Inner		;Yes, try another addr
	LD A,(HL)
	CP E
	JR Z Inner		;Yes, try another addr
	LD (HL),E 		;Print fill chr
;Check for key down
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	JR Z NoKey		;Jump if keypress
;Check for key up
@Wait
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	JR NZ Wait		;Jump if keypress
	LD A,01			;Set keypress flag to 1
	JR SetFlag
@NoKey
	POP DE			;POP counter
	DEC DE			;Decrease counter
	LD A,D 
	OR E
	JR NZ Outer		;Loop until DE=0
@SetFlag
	LD (Buff1),A		;Set keypress flag to 0 or 1
	RST 08			;Return via Error Restart, skipping the PRINT routine
	FF
;================================
; Calculate count value
;================================
@Count
	LD DE,0000		;Initialize counter
	LD BC,0319		;CPI counter, 793
	LD HL,(DFile)		;Get DFile addr
@NextDF
	LD A,(Buff1)		;Get fill chr
@TestFill
	CPI			;(HL)=Fill?
	JR Z TestFill		;Jump if (HL)=fill
	INC DE			;Increase counter
	LD A,B			;Test CPI counter (JP PO not allowed)
	OR C
	JR NZ NextDF		;Loop until CPI counter=0
	EX DE,HL		;HL=Count+N/Ls
	LD C,19			;N/L count
	SBC HL,BC		;Subtract N/L count
	EX DE,HL		;DE=Count
	JR Outer		;"RET"
;=============================
;Generate a random number between 0 and 32768
;This routine extracted from MCoder II
;=============================
	JR PrintFill
@RNDNum
	LD DE,(Seed)
	LD H,E 
	LD L,FD 
	LD A,D 
	OR A 
	LD B,00 
	SBC HL,DE 
	SBC A,B 
	SBC HL,DE 
	SBC A,B 
	LD E,A 
	LD D,B 
	SBC HL,DE 
	JR NC +1
	INC HL 
	LD (Seed),HL
;=============================
;This section limits the range to 0 to 792 (0 to 0318)
;=============================
	LD B,00		
	LD C,L
	LD A,H
@MSB3
	CP C0		;MSB>192?
	JR C MSB2
	LD B,03
	LD A,C
	CP 18
	JR C LSBOK
	LD A,18		;Trim LSB
@LSBOK
	LD C,A
	JR RNDNum-2
@MSB2
	CP 80		;MSB>128?
	JR C MSB1
	LD B,02
	JR RNDNum-2
@MSB1
	CP 40		;MSB>64?
	JR C MSB0
	LD B,01
@MSB0
	JR RNDNum-2