;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Screen Eraser
;
;  PRINT USR ERAS;[Speed][CODE "CHR X"]
;
;================================
@StackBC=0BF5		;Move results to BC
@Class6=0D92		;Expression evaluator, if value>255 then error B
@DFile=400C		;Start of DFile
@Speed=407C		;Spare3, Speed value IY+124

@Eraser
	RST 20		;Get next character
	LD A,75		;Check for parameters
	INC A
	CP (HL)
	LD B,00		;Default fill
	LD A,01		;Default speed
	JR Z NoPars	;Jump if no parameters
	CALL Class6	;Evaluate [Speed] expression 
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Fill, A=C=Speed
@NoPars
	LD D,B		;D=fILL
	LD (Speed),A	;Store Speed
	LD HL,(DFile)
	INC HL
	LD A,FF		;Odd/Even row flag
	LD B,18		;Row count
@Loop
	LD E,20		;Column count
	CPL		;Test for odd/even row
	AND A
	JR NZ OddRow	;Jump if odd row
@EvenRow
	LD (HL),D	;Print fill
	LD C,(IY+124)	;Delay loop
	DEC C
	PUSH HL
	PUSH HL
	POP HL
	POP HL
	JR NZ -7
	INC HL		;Next DFile addr
	DEC E		;Decrease column counter
	JR NZ EvenRow	;Loop until E=0
	PUSH BC		;PUSH row counter
        LD C,20		;Offset to next row
	JR NextRow
@OddRow
	LD (HL),D
	LD C,(IY+124)	;Delay loop
	DEC C
	PUSH HL
	PUSH HL
	POP HL
	POP HL
	JR NZ -7
	DEC HL		;Next column left
	DEC E		;Decrease column counter
	JR NZ OddRow	;Loop until E=0
	PUSH BC		;PUSH row counter
	LD C,22		;Offset to next row
@NextRow
	LD B,E
	ADD HL,BC	;Add offset to current DFile addr
	POP BC		;POP row counter
	DJNZ Loop	;Loop
	RST 08
	FF