;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Fill screen with fill chr
;
; PRINT USR FILL;[Lines],[CODE "Chr X"]
;
;================================

@DFile=400C		;Start of DFile
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC

@Fill
	RST 20		;Get next character
	LD BC,1800	;Default Lines (B) & Chr (C)
	LD A,75
	INC A
	CP (HL)
	JR Z CLS	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Chr, A=C=Lines
	LD A,B		;Swap B & C
	LD B,C		;B=Lines
	LD C,A		;C=Chr
@CLS
	LD HL,0000	;Calculate byte count
	LD DE,0021	;Bytes/Row
@Bytes
	ADD HL,DE
	DJNZ Bytes	;Loop until B=0
	EX DE,HL	;DE=Byte count
	LD HL,(DFile)	;Get DFile
	INC HL
@Loop
	LD A,(HL)	;Get DFile chr
	BIT 6,A		;N/L?
	JR NZ +1	;Jump if N/L
	LD (HL),C	;Replace with fill chr
	INC HL		;Increase DFile addr
	DEC DE		;Decrease counter
	LD A,D 
	OR E 
	JR NZ Loop	;Loop until DE=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF