;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Hyperspace Jump
;
; PRINT USR HYPR;[Speed]["Sequence"]
;
;================================

@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A
@DFile=400C		;Start of DFile
@CHAdd=4016		;Address of next character
@LastK=4025		;Key press value
@Buff01=403C		;Speed storage
@Buff03=403E		;Fill chr. storage

@Hyper
	RST 20		;Get next character
	CALL Class6	;Evaluate [Speed] expression
	CALL StackA	;Move results to A, A=Speed
	LD B,A		;B=Speed
	LD C,01
	LD (Buff01),BC	;Store speed at Buff01
	RST 20		;Skip ,
	EX DE,HL	;DE=Start of jump sequence-1
@Outer
	LD HL,(DFile)	;Get DFile
	LD BC,0319	;DFile size
	INC DE		;Next data chr
	LD A,(DE)	;Get data chr
	CP 0B		;;EOL?
	JR Z End	;IF EOL then Return to BASIC
	LD (Buff03),A	;Store fill chr at Buff03
@Inner
	LD A,(HL)	;N/L?
	BIT 6,A
	JR NZ SkipNL	;Jump if N/L
	LD A,(Buff03)	;Get fill chr
	LD (HL),A	;Fill with chr
@SkipNL
	INC HL		;Increase DFile addr
	DEC BC		;Decrease counter
	LD A,B 
	OR C 
	JR NZ Inner	;Loop until BC=0
;Check for keypress
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	LD BC,(Buff01)	;Get Speed
@DLay
	DEC BC		;Decrease counter
	LD A,B 
	OR C 
	JR NZ DLay	;Loop until BC=0
	JR Outer
@Wait
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
@End
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
