;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; IReg "Explosion"
;
; PRINT USR IREG;[Speed]
;
;================================

@DFile=400C		;DFile address
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackA=0C02		;Move results to A

@IReg
	RST 20		;Get next character
	LD B,05		;Default speed value
	LD A,75
	INC A
	CP (HL)
	JR Z NoPar	;Jump if no value specified
	CALL Class6	;Evaluate [Speed] expression
	CALL StackA	;move results to A, A=Speed
	LD B,A		;B=Speed value
@NoPar
	LD C,01
	LD A,FF		;Initialize IReg counter
@Loop
	PUSH BC		;PUSH delay counter
	INC A
	CP 1E		;30?
	LD I,A		;Set Ireg
	JR NZ DLay-1
	POP BC		;Clear stack
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF
	LD E,A		;Save A to E
@DLay
	DEC BC		;Decrease counter
	LD A,B 
	OR C 
	JR NZ DLay	;Loop until BC=0
	LD A,E		;Restore A from E
	POP BC		;POP delay counter
	JR Loop		;Loop until A=30