;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Fill screen with fill chr
;
; PRINT USR MELT;[Speed],[CODE "Chr X"]
;
;================================

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackBC=0BF5			;Move results to BC
@DFile=400C			;Start of DFile
@LastK=4025			;Key press value
@Seed=4032			;Random Number Seed
@Buff1=403C			;Fill value, IY+60
@Buff2=403D			;Speed value, IY+61

@Melt
	RST 20			;Get next character
	LD B,00			;Default fill chr
	LD A,75			;Test for parameters
	INC A
	CP (HL)
	LD A,01			;Default speed
	JR Z NoPars		;Jump if no value specified
	CALL Class6		;Evaluate [Speed] expression
	RST 20 			;Get next character
	CALL Class6		;Evaluate [CODE "Chr X"] expression
	CALL StackBC		;Move results to BC, B=Chr, A=C=Speed
@NoPars
	LD (IY+60),B		;Buff1=Chr
	LD (Buff2),A		;Buff2=Speed
	JR Count		;"CALL Count" 
	PUSH DE			;PUSH counter
@NextX
	POP DE			;POP counter
	PUSH DE			;PUSH counter
@RndX
	JR RNDNum		;"CALL RNDNum", Xcoord=0 to 31
	LD D,(IY+60)		;D=Fill chr
	LD HL,(DFile)		;Locate column addr
	INC HL
	ADD HL,BC		;Add Xcoord
	LD BC,0021		;Bytes/row
	SBC HL,BC
	LD E,19			;E=Row count
@NextY
	ADD HL,BC		;Next row addr
	DEC E			;Last row?
	JR Z NextX		;Jump if last row
	LD A,(HL)		;Check for fill chr
	CP D			;Fill chr?
	JR Z NextY		;Loop if fill chr.
	LD (HL),D		;Print fill chr
;Check for key down
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	JR Z NoKey		;Jump if keypress
;Check for key up
@Wait
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	JR NZ Wait		;Jump if keypress
	LD A,01			;Set keypress flag to 1
	JR SetFlag
@NoKey
	LD A,(Buff2)		;Get delay value
	DEC A
	JR NZ -3		;Loop until A=0
	POP DE			;POP counter
	DEC DE			;Decrease counter
	LD A,D 
	OR E 
	JR NZ NextX+1		;Loop until DE=0
@SetFlag
	LD (Buff1),A		;Set keypress flag to 0 or 1
	RST 08			;Return via Error Restart, skipping the PRINT routine
	FF
;================================
; Calculate count value
;================================
@Count
	LD DE,0000		;Initialize counter
	LD BC,0319		;CPI counter, 793
	LD HL,(DFile)		;Get DFile addr
@NextDF
	LD A,(Buff1)		;Fill chr
@TestFill
	CPI			;(HL)=Fill?
	JR Z TestFill		;Jump if (HL)=fill
	INC DE			;Increase counter
	LD A,B			;Test CPI counter (JP PO not allowed)
	OR C
	JR NZ NextDF		;Loop until CPI counter=0
	EX DE,HL		;HL=Count
	LD C,19			;Adjust for N/L chrs
	SBC HL,BC
	EX DE,HL		;DE=Count
	JR NextX-1		;"RET"
;================================
; Return random number between 0 and 31
;================================
@RNDNum
	LD DE,(Seed)
	LD H,E 
	LD L,FD 
	LD A,D 
	OR A 
	LD B,00 
	SBC HL,DE 
	SBC A,B 
	SBC HL,DE 
	SBC A,B 
	LD E,A 
	LD D,B 
	SBC HL,DE 
	JR NC +1
	INC HL 
	LD (Seed),HL
	LD A,L
	AND 1F
	LD B,00
	LD C,A
	JR RndX+2