;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Quick Print
;
;  PRINT USR QPRT;C$
;  PRINT USR QPRT;"YcoordXcoordText"
;
;================================

@NextOne=09F2
@Report2=0D4B
@DFile=400C
@Vars=4010

@SpritePrint			;Print Sprite
	RST 20	 		;Next chr
	CP 0B			;Quote Mark?
	JR Z GetYX		;Jump if quoted text
;Locate string var
	ADD A,20
	LD C,A			;C=Chr code+32
	LD HL,(Vars)		;Get start of Vars
@NextVar
	LD A,(HL)		;Get var
	CP C			;Match?
	JR Z Found 		;Jump if match
	CP 80 			;End of Vars?
	JP Z Report2		;Jump if variable not found
	PUSH BC			;PUSH string id
	CALL NextOne		;Locate next variable
	POP BC			;POP string id
	EX DE,HL
	JR NextVar
@Found
	INC HL			;Skip var header
	INC HL
@GetYX
;Convert YXcoords to digit
	LD E,1C			;28
	INC HL			;Ycoord addr
	LD A,(HL)		;Get Ycoord
	SUB E			;Digit=Chr code-28
	LD B,A			;B=Ycoord
	INC HL			;Xcoord addr
	LD A,(HL)		;Get Xcoord
	SUB E			;Digit=Chr code-28
	LD C,A			;C=Xcoord
@Paragraph
	PUSH HL			;PUSH text pointer
;Calculate DFile address
	LD DE,0021		;Bytes/row
	LD HL,(DFile)		;Get DFile
	INC HL
	LD A,B			;Test Ycoord
	AND A			;0?
	JR Z AddX		;Jump if Ycoord=0
@AddY
	ADD HL,DE		;Add row offset
	DJNZ AddY
@AddX
	ADD HL,BC		;Add column offset
	LD C,E			;BC=0021
	POP DE			;POP text pointer
	PUSH HL			;PUSH DFile pointer
@Chr
	INC DE			;Increase text pointer
	LD A,(DE)		;Get chr to print
	CP 0B			;End of text marker?
	JR Z End		;Jump if end of text
	CP D8			;**, N/L?
	JR Z NextRow		;Jump if N/L marker
	CP DD			;<>, New sprite?
	JR NZ SkipNL		;Jump if not new sprite
	POP HL			;Clear the stack
	EX DE,HL		;HL=Text pointer
	JR GetYX		;Yes, start next sprite
@SkipNL
	LD A,(HL)		;Get DFile chr
	BIT 6,A			;N/L?
	JR Z NotNL		;Jump if not N/L
	INC HL			;Skip N/L
@NotNL
	LD A,(DE)		;Get chr to print
	LD (HL),A		;Print the chr.
	INC HL			;Increase DFile pointer
	JR Chr			;Print/test next chr.
@NextRow
	POP HL			;POP DFile pointer
	ADD HL,BC		;Next row
	JR Chr-1		;Start next row
@End
	POP HL			;Clear the stack
	RST 08			;Return via Error Restart, skipping the PRINT routine
	FF
