;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Scroll Left
;
; PRINT USR Left;[Lines][CODE "Chr X"]
;
;================================

@DFile=400C
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC

@Left
	RST 20		;Get next character
	LD BC,0100	;Default Lines (B) & Chr (C)
	LD A,75
	INC A
	CP (HL)
	LD A,C		;A=Default Chr
	JR Z Outer	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression 
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Chr, A=C=Lines
	LD A,B		;Swap B & C
	LD B,C		;B=Lines
@Outer
	PUSH BC		;PUSH scroll counter
	LD DE,(DFile)	;Get DFile
	INC DE		;Set destination
	LD BC,181F	;Set counters, B=rows C=LDIR
	LD H,D		;Setup for LDIR
	LD L,E
@Inner
	PUSH BC		;PUSH row counter
	INC HL
	LD B,00
	LDIR
;Erase column 23
	LD (DE),A
	INC DE		;Start next row
	INC DE
	INC HL		;Skip N/L
	POP BC		;POP row counter
	DJNZ Inner	;Loop until row counter=0
	POP BC		;POP scroll counter
	DJNZ Outer	;Loop until scroll counter=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF