;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Scroll Right
;
; PRINT USR RITE;[Lines][CODE "Chr X"]
;
;================================

@DFile=400C
@Class6=0D92		;Expression evaluator, if value>255 then error B
@StackBC=0BF5		;Move results to BC

@Rite
	RST 20		;Get next character
	LD BC,0100	;Default Lines (B) & Chr (C)
	LD A,75
	INC A
	CP (HL)
	LD A,C		;A=Default Chr
	JR Z Outer	;Jump if no value specified
	CALL Class6	;Evaluate [Lines] expression 
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr X"] expression
	CALL StackBC	;Move results to BC, B=Chr, A=C=Lines
	LD A,B		;Swap B & C
	LD B,C		;B=Lines
@Outer
	PUSH BC		;PUSH scroll counter
	LD HL,(DFile)	;Get DFile
	DEC HL		;Decrease so offset of BC=0021 works
	LD B,18		;Row counter
@Inner
	PUSH BC		;PUSH counter
	LD BC,0021	;Offset to right margin
	ADD HL,BC	;HL=Right margin
	PUSH HL		;PUSH right margin
;Shift row right
	LD D,H		;Setup for LDDR
	LD E,L
	DEC DE
	EX DE,HL
	LD C,1F
	LDDR
;Erase column 0
	LD (DE),A
	POP HL		;POP right margin
	POP BC		;POP counter
	DJNZ Inner	;Loop until B=0
	POP BC		;POP scroll counter
	DJNZ Outer	;Loop until B=0
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF