;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Scrolling Text
;
;  PRINT USR STXT;[Row #][Speed]["Text to print"]
;
;================================
@StackBC=0BF5		;Move results to BC
@Class6=0D92		;Expression evaluator, if value>255 then error B
@DFile=400C		;Start of DFile
@CHAdd=4016		;Address of next character
@LastK=4025		;Key press value
@Text=403C		;Text data
@End=403E		;PRINT AT address
@Start=4040		;Line start
@Speed=4042		;Speed value

@ScrollTxt
	RST 20		;Get next character
	CALL Class6	;Evaluate [CODE "Chr A"] expression
	RST 20 		;Get next character
	CALL Class6	;Evaluate [CODE "Chr B"] expression
	CALL StackBC	;Move results to BC, B=Speed, A=C=Row
	LD (IY+66),B	;Save speed value
	LD HL,(DFile)	;Get DFile
	INC HL
	LD B,C		;B=Ycoord
	LD C,1F		;C=XCoord
	AND A		;Test Ycoord for 0
	JR Z AddX	;Jump if Ycoord=0
	LD DE,0021	;Bytes/row
@AddY
	ADD HL,DE	;Add row offset
	DJNZ AddY
@AddX
	ADD HL,BC	;Add column offset
	LD (End),HL	;Save line end address
	DEC C
	AND A
	SBC HL,BC
	LD (Start),HL	;Save line start address
	RST 20		;Skip ,
	LD (Text),HL	;Save text start address
	EX DE,HL
@Loop
	PUSH DE		;PUSH text pointer
	LD C,1F		;Setup for LDIR
	LD HL,(Start)	;Scroll line left
	LD D,H
	LD E,L
	DEC DE
	LDIR
	POP DE		;POP text pointer
@Rewind
	INC DE		;Next chr
	LD A,(DE)	;Get chr to print
	CP 0B		;EOL?
	JR NZ TestC0	;Jump if not EOL
	LD DE,(Text)	;Get text start address
	JR Rewind
@TestC0
	CP C0		;"" symbol?
	JR NZ +2	;Jump if not ""
	LD A,0B		;Print "
	LD HL,(End)	;Get line end address
	LD (HL),A	;Print chr.
;Check for keypress
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	LD B,(IY+66)	;Get speed value
	LD C,01
@DLay
	DEC BC		;Decrease counter
	LD A,B 
	OR C 
	JR NZ DLay	;Loop until BC=0
	JR Loop
@Wait
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	RST 08		;Return via Error Restart, skipping the PRINT routine
	FF

